from Acquisition import aq_base
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory


import Ping
import TrackbackTool
from config import product_name, skin_name

import sys

this_module = sys.modules[__name__]

bases = (Ping.Ping,)
tools = (TrackbackTool.TrackbackTool,)

z_bases = utils.initializeBasesPhase1(bases, this_module)
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)

global trackback_globals
trackback_globals=globals()

registerDirectory('skins', globals())


def initialize(context):

    utils.initializeBasesPhase2(z_bases, context)
    utils.initializeBasesPhase2(z_tool_bases, context)

    utils.ToolInit('CMFTrackback Tool', tools=tools,
                   product_name='CMFTrackback', icon='tool.png',
                   ).initialize(context)
    utils.ContentInit('CMFTrackback Item',
                      content_types=(bases),
                      fti=Ping.factory_type_information
                      ).initialize(context)

    # patch opaqueItems for trackback!!
    def opaqueItems(self):
        x = []
        if hasattr(aq_base(self), 'talkback'):
            talkback = self.talkback
            if talkback is not None:
                x.append((talkback.id, talkback))
        if hasattr(aq_base(self), 'trackback'):
            trackback = self.trackback
            if trackback is not None:
                x.append((trackback.id, trackback))
        return x
    
    import Products
    Products.CMFCore.CMFCatalogAware.CMFCatalogAware.opaqueItems = opaqueItems
